#version 300 es

//ANDROID#define ANDROID

// uniforms
#ifdef ANDROID
uniform vec4 u_mats[/U_MATS_SIZEx4/];
#else
uniform mat4 u_mats[/U_MATS_SIZE/];
#endif

// attributes
layout(location = 0) in vec4 a_position_i;
layout(location = 2) in vec2 a_uv;

// varying
out vec2 v_uv;

void main()
{
    int i       = int(a_position_i.w);
#ifdef ANDROID
    int j       = i << 2;
    gl_Position = mat4(u_mats[j++], u_mats[j++], u_mats[j++], u_mats[j]) * vec4(a_position_i.xyz, 1.);
#else
    gl_Position = u_mats[i] * vec4(a_position_i.xyz, 1.);
#endif
    
    v_uv = a_uv;
}
