#ifdef GL_ES
precision mediump float;
#endif

uniform vec3 u_mask_color;

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

void main()
{
    vec3 m = step(abs(texture2D(CC_Texture0, v_texCoord + vec2(0., 0.5)).rgb - u_mask_color), vec3(0.005));
    
    gl_FragColor = texture2D(CC_Texture0, v_texCoord) * v_fragmentColor * (m.r * m.g * m.b);
}
