#version 300 es

precision lowp float;

// uniforms
uniform vec4      u_color;
uniform sampler2D u_texture;

// varying
in  vec2 v_uv;

out vec4 fragmentColor;

void main()
{
    vec4 c = texture(u_texture, v_uv);
    c.rgb  = c.rgb * (1. - u_color.a) + u_color.rgb * u_color.a;
    fragmentColor = c;
}
